/*
 * Copyright (c) 2005-2010 KOM – Multimedia Communications Lab
 *
 * This file is part of PeerfactSim.KOM.
 * 
 * PeerfactSim.KOM is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * any later version.
 * 
 * PeerfactSim.KOM is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with PeerfactSim.KOM.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

package de.tud.kom.p2psim.impl.topology.movement.smarter.metrics;

import java.util.List;

import de.tudarmstadt.maki.simonstrator.api.Host;
import de.tudarmstadt.maki.simonstrator.api.Time;
import de.tudarmstadt.maki.simonstrator.api.common.metric.AbstractMetric;

public class TotalDistanceWalked extends AbstractMetric<de.tud.kom.p2psim.impl.topology.movement.smarter.metrics.TotalDistanceWalked.SmarterHosts>{
	public TotalDistanceWalked() {
		super("Calculates the total distance walked by the nodes.", MetricUnit.NONE);
	}

	public void initialize(List<Host> hosts) {
		System.out.println("TotalDistanceWalked");
	}

	public class SmarterHosts implements de.tudarmstadt.maki.simonstrator.api.common.metric.Metric.MetricValue<Integer> {
		int count;

		private long lastCalcTimestamp;

		public SmarterHosts() {
		}

		@Override
		public Integer getValue() {
			calc();
			return count;
		}

		public void calc() {
			if (Time.getCurrentTime() == lastCalcTimestamp)
				return;
			lastCalcTimestamp = Time.getCurrentTime();
			count = 0;

		}

		@Override
		public boolean isValid() {
			return true;
		}

	}
}
